b2_copy_part
  • 11 Sep 2026
  • Dark
    Light

b2_copy_part

  • Dark
    Light

Article summary

Post
/b2api/v4/b2_copy_part

Copies part of a file

NOTE:

The destination part inherits the encryption selected for the destination large file.

For more information, see Server-Side Encryption.

Copies from an existing B2 file, storing it as a part of a large file which has already been started with b2_start_large_file.

When calling b2_copy_part, by default the entire source file will be copied to the destination. If you wish, you may supply a range param to only copy a portion of the source file over.


NOTE:

This API endpoint can be called using a GET request by converting the parameters in the request body to query parameters.

Header parameters
Authorization
stringRequired

An account authorization token, obtained from b2_authorize_account.

The token must have the writeFiles capability and the readFiles capability if the bucket is private.

Body parameters
Expand All
object
sourceFileId
string Required

The ID of the source file being copied.

ExampleSOURCE_FILE_ID
largeFileId
string Required

The ID of the large file the part will belong to, as returned by b2_start_large_file.

ExampleBUCKET_ID
partNumber
integer Required

A number from 1 to 10000. The parts uploaded for one file must have contiguous numbers, starting with 1.

Example1
range
string

The range of bytes to copy. If not provided, the whole source file will be copied.

Examplebytes=0-4999999
sourceServerSideEncryption
object

If present, specifies the parameters for Backblaze B2 to use for accessing the source file data using Server-Side Encryption. This parameter must be provided only if the source file has been encrypted using Server-Side Encryption with Customer-Managed Keys (SSE-C), and the provided encryption key must match the one with which the source file was encrypted. See Server-Side Encryption for details.

Example{ "mode": "SSE-C", "algorithm": "AES256", "customerKey": "<base64-encoded AES-256 encryption key>", "customerKeyMd5": "<base64-encoded MD5 digest of the key>" }
mode
string
algorithm
string
customerKey
string
customerKeyMd5
string
destinationServerSideEncryption
object

If present, specifies the parameters for Backblaze B2 to use for encrypting the copied data before storing the destination file using Server-Side Encryption. This parameter must be provided only if the large file was started with Server-Side Encryption with Customer-Managed Keys (SSE-C), and the provided encryption key must match the one with which the large file was started. See Server-Side Encryption for details.

Example{ "mode": "SSE-C", "algorithm": "AES256", "customerKey": "<base64-encoded AES-256 encryption key>", "customerKeyMd5": "<base64-encoded MD5 digest of the key>" }
mode
string
algorithm
string
customerKey
string
customerKeyMd5
string
Responses
200

The request succeeded.

Expand All
object
fileId
string

The file ID for uploading this file.

ExampleFILE_ID
partNumber
integer

Which part this is.

Example1
contentLength
integer

The number of bytes stored in the part.

Example99212871
contentSha1
string

The SHA1 of the bytes stored in the file as a 40-digit hex string. Large files do not have SHA1 checksums, and the value is "none". The value is null when the action is "hide" or "folder".

Examplec604542967a93466d4ed087956753161cfab3f31
contentMd5
string

The MD5 of the bytes stored in the part. Not all parts have an MD5 checksum, so this field is optional, and set to null for parts that do not have one.

Example142be8357f26eda2ec6775cce257753b
serverSideEncryption
object

When the part is encrypted with Server-Side Encryption, the mode ("SSE-B2" or "SSE-C") and algorithm used to encrypt the data.

Example{ "algorithm": null, "mode": null }
mode
string
algorithm
string
uploadTimestamp
integer

This is a UTC time when this part was uploaded. It is a base 10 number of milliseconds since midnight, January 1, 1970 UTC. This fits in a 64 bit integer such as the type "long" in the programming language Java. It is intended to be compatible with Java's time long. For example, it can be passed directly into the java call Date.setTime(long time).

Example1559585618236
400
statuscodedescription
400bad_bucket_idThe requested bucket ID does not match an existing bucket.
400bad_requestThe request had the wrong fields or illegal values. The message returned with the error will describe the problem.
400source_too_largeThe source file being copied is too large.
object
status
integer

The numeric HTTP status code. Always matches the status in the HTTP response.

Example400
code
string

A single-identifier code that identifies the error.

Exampleinvalid_bucket_name
message
string

A human-readable message, in English, saying what went wrong.

Examplebucket name is too long
401
statuscodedescription
401bad_auth_tokenThe auth token used is not valid. Call b2_authorize_account again to either get a new one, or an error message describing the problem.
401expired_auth_tokenThe auth token used has expired. Call b2_authorize_account again to get a new one.
401unauthorizedThe auth token used is valid, but does not authorize this call with these parameters. The capabilities of an auth token are determined by the application key used with b2_authorize_account.
403
statuscodedescription
403access_deniedThe provided customer-managed encryption key is wrong.
403transaction_cap_exceededTransaction cap exceeded. Daily transaction caps apply to non-paying accounts. To view or adjust your caps, sign in to your B2 Cloud Storage account online and select the Caps & Alerts link in the B2 Cloud Storage section of the sidebar.
404
statuscodedescription
404not_foundFile is not in B2 Cloud Storage.
405
statuscodedescription
405method_not_allowedmethod not allowed: <HTTP METHOD>
408
statuscodedescription
408request_timeoutThe service timed out reading the uploaded file
416
statuscodedescription
416range_not_satisfiableThe Range header in the request is valid but cannot be satisfied for the file.

Was this article helpful?